/*
 * Copyright (c) 2010, Paul Merlin. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package org.codeartisans.sked.crontab;

import java.util.Comparator;
import java.util.TreeMap;

import org.codeartisans.sked.crontab.schedule.CronSchedule;

/**
 * @author Paul Merlin
 */
public class CrontabImpl
        extends TreeMap<CronSchedule, Runnable>
        implements Crontab
{

    public CrontabImpl()
    {
        super( new Comparator<CronSchedule>()
        {

            @Override
            public int compare( CronSchedule o1, CronSchedule o2 )
            {
                long now = System.currentTimeMillis();
                return o1.firstRunAfter( now ).compareTo( o2.firstRunAfter( now ) );
            }

        } );
    }

}
